#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x28TN1x1x28_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=28, 
 * lda=28, ldb=28, ldc=0, mu=1, nu=1, ku=28, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.1)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (28*(Mb));
   const float *stN = B + (28*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 28
   const int incAm = 0, incAn = -(28*(Mb));
   #define incBk 28
   const int incBm = -28, incBn = 28;
   const int incAk0 = ((incAk) / 28), incBk0 = ((incBk) / 28);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float m0, m1, m2, m3;
   register float rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         m1 = rA0 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         m2 = rA0 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         m3 = rA0 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[27];
         rB0 = pB0[27];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rC0_0 += m0;
         rC0_0 += m1;
         rC0_0 += m2;
         rC0_0 += m3;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x28TN28x28x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=28, 
 * lda=28, ldb=28, ldc=0, mu=3, nu=1, ku=28, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.1)
 */
{
   const int Mb = (M/3)*3;
   #define Nb N
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (28*(Mb));
   const float *stN = B + (28*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*3*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 28
   const int incAm = 56, incAn = -(28*(Mb));
   #define incBk 28
   const int incBm = -28, incBn = 28;
   const int incAk0 = ((incAk) / 28), incBk0 = ((incBk) / 28);
   #define incCm 3
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2;
   register float rB0;
   register float m0, m1, m2, m3;
   register float rC0_0, rC1_0, rC2_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[28];
            m0 = rA0 * rB0;
            rA2 = pA0[56];
            m1 = rA1 * rB0;
            m2 = rA2 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[29];
            rA2 = pA0[57];
            m3 = rA0 * rB0;

/*
 *          Completely unrolled K-loop
 */
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[30];
            rA2 = pA0[58];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[31];
            rA2 = pA0[59];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[32];
            rA2 = pA0[60];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[33];
            rA2 = pA0[61];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[34];
            rA2 = pA0[62];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[35];
            rA2 = pA0[63];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA0[36];
            rA2 = pA0[64];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rA1 = pA0[37];
            rA2 = pA0[65];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rA1 = pA0[38];
            rA2 = pA0[66];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rA1 = pA0[39];
            rA2 = pA0[67];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rA1 = pA0[40];
            rA2 = pA0[68];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rA1 = pA0[41];
            rA2 = pA0[69];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rA1 = pA0[42];
            rA2 = pA0[70];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rA1 = pA0[43];
            rA2 = pA0[71];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rA1 = pA0[44];
            rA2 = pA0[72];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rA1 = pA0[45];
            rA2 = pA0[73];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rA1 = pA0[46];
            rA2 = pA0[74];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rA1 = pA0[47];
            rA2 = pA0[75];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[20];
            rB0 = pB0[20];
            rA1 = pA0[48];
            rA2 = pA0[76];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[21];
            rB0 = pB0[21];
            rA1 = pA0[49];
            rA2 = pA0[77];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[22];
            rB0 = pB0[22];
            rA1 = pA0[50];
            rA2 = pA0[78];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[23];
            rB0 = pB0[23];
            rA1 = pA0[51];
            rA2 = pA0[79];
            rC2_0 += m1;
            m1 = rA0 * rB0;
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rA0 = pA0[24];
            rB0 = pB0[24];
            rA1 = pA0[52];
            rA2 = pA0[80];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC0_0 += m1;
            m1 = rA1 * rB0;
            rC1_0 += m2;
            m2 = rA2 * rB0;
            rA0 = pA0[25];
            rB0 = pB0[25];
            rA1 = pA0[53];
            rA2 = pA0[81];
            rC2_0 += m3;
            m3 = rA0 * rB0;
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m1;
            m1 = rA2 * rB0;
            rA0 = pA0[26];
            rB0 = pB0[26];
            rA1 = pA0[54];
            rA2 = pA0[82];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC0_0 += m3;
            m3 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rA0 = pA0[27];
            rB0 = pB0[27];
            rA1 = pA0[55];
            rA2 = pA0[83];
            rC2_0 += m1;
            m1 = rA0 * rB0;
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m2;
            m2 = rA1 * rB0;
            rC1_0 += m3;
            m3 = rA2 * rB0;
            rC2_0 += m0;
            rC0_0 += m1;
            rC1_0 += m2;
            rC2_0 += m3;
            pA0 += incAk;
            pB0 += incBk;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x28TN1x1x28_a1_bX(k, N, 28, alpha, ca + (28*(Mb)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
