#define ATL_USERMM ATL_cJIK60x60x60TN60x60x0_a1_b0
#define ATL_USERMM_b1 ATL_cJIK60x60x60TN60x60x0_a1_b1
#define ATL_USERMM_bn1 ATL_cJIK60x60x60TN60x60x0_a1_bn1
#define ATL_USERMM_b0 ATL_cJIK60x60x60TN60x60x0_a1_b0
#define ATL_USERMM_bX ATL_cJIK60x60x60TN60x60x0_a1_bX
#define BETA0
#define SCPLX

#define MB 60
#define NB 60
#define KB 60

#define MBMB 3600
#define NBNB 3600
#define KBKB 3600

#define MB2 120
#define NB2 120
#define KB2 120


#define MB3 180
#define NB3 180
#define KB3 180


#define MB4 240
#define NB4 240
#define KB4 240


#define MB5 300
#define NB5 300
#define KB5 300


#define MB6 360
#define NB6 360
#define KB6 360


#define MB7 420
#define NB7 420
#define KB7 420


#define MB8 480
#define NB8 480
#define KB8 480

#ifdef BETA0
#define ATL_INT int
#include <stdio.h>
#include <stdint.h>
#include <pmmintrin.h>

#define I_UNROLL 6
#define J_UNROLL 1
/* Is prefetched data written or just read? */
#define PF_READONLY 0
#define PF_READWRITE 1
#define PF_NO_REUSE 0

/* Default temporality of cache prefetch (1-3) */
#define PF_DEF 1
#define CACHE_LINE_SIZE 64
#define MMCAST( a ) (a)
#define MMCASTStore( a ) (a)
#define MMCASTStoreintrin( a ) (a)
#define TYPE float
void ATL_USERMM( const ATL_INT M, const ATL_INT N, const ATL_INT K,
                 const TYPE alpha, const TYPE *A, const ATL_INT lda,
                 const TYPE *B, const ATL_INT ldb,
                 const TYPE beta, TYPE *C, const ATL_INT ldc )
{
   register ATL_INT i, j, k;
   
   /* Vector registers to hold the elements of C */
   __m128 c0_0, c0_1, c0_2, c0_3, c0_4, c0_5;
   /* Temporary vector registers for use in inner loop */
   __m128 temp; 
   __m128 temp0;  
   __m128 temp1;  
   __m128 temp2;  
   __m128 temp3;  
   /* Pointer adjustments */  
   register const ATL_INT ldc_bytes = 2*ldc;
   
   register TYPE const *B0_off = B;
      
   register void const * prefetchABlock =  (void*)(A + 60*KB); 
   
   /* Unroll A */
   __m128 A0, a0, A1, a1, A2, a2, A3, a3, A4, a4, A5, a5;
   /* Unroll B */
   __m128 B0, B1;
   

   register const ATL_INT unroll_a = I_UNROLL*KB;
   register TYPE* cPtr = C;
   

   const ATL_INT pfBlockDistance = (6 * 1 * KB * 4) / 60;
   /* =======================================
    * Begin generated inner loops for case Non aligned
    * ======================================= */
   for( j=-60; j!=0; j+=J_UNROLL) 
   {
      register TYPE const *A0_off = A; 
      
      register TYPE *cPtrI0 = cPtr;
      

      for( i=-60; i != 0; i+= I_UNROLL )
      {
         /* K_Unrolling0 */
         A0 = _mm_load_ps( MMCAST(A0_off) );
         A1 = _mm_load_ps( MMCAST(A0_off + 60) );
         A2 = _mm_load_ps( MMCAST(A0_off + 120) );
         A3 = _mm_load_ps( MMCAST(A0_off + 180) );
         A4 = _mm_load_ps( MMCAST(A0_off + 240) );
         A5 = _mm_load_ps( MMCAST(A0_off + 300) );
         B0 = _mm_load_ps( MMCAST(B0_off) );
         c0_0 = B0;
         c0_0 = _mm_mul_ps( A0, c0_0 );
         c0_1 = B0;
         c0_1 = _mm_mul_ps( A1, c0_1 );
         c0_2 = B0;
         c0_2 = _mm_mul_ps( A2, c0_2 );
         c0_3 = B0;
         c0_3 = _mm_mul_ps( A3, c0_3 );
         c0_4 = B0;
         c0_4 = _mm_mul_ps( A4, c0_4 );
         c0_5 = B0;
         c0_5 = _mm_mul_ps( A5, c0_5 );
         
         /* Prefetch one element from the next block of A */
         __builtin_prefetch( prefetchABlock + 0*pfBlockDistance,PF_READONLY, PF_DEF );
         /* K_Unrolling: 4 */
         A0 = _mm_load_ps( MMCAST(A0_off + 4) );
         A1 = _mm_load_ps( MMCAST(A0_off + 64) );
         A2 = _mm_load_ps( MMCAST(A0_off + 124) );
         A3 = _mm_load_ps( MMCAST(A0_off + 184) );
         A4 = _mm_load_ps( MMCAST(A0_off + 244) );
         A5 = _mm_load_ps( MMCAST(A0_off + 304) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 4) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 8 */
         A0 = _mm_load_ps( MMCAST(A0_off + 8) );
         A1 = _mm_load_ps( MMCAST(A0_off + 68) );
         A2 = _mm_load_ps( MMCAST(A0_off + 128) );
         A3 = _mm_load_ps( MMCAST(A0_off + 188) );
         A4 = _mm_load_ps( MMCAST(A0_off + 248) );
         A5 = _mm_load_ps( MMCAST(A0_off + 308) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 8) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 12 */
         A0 = _mm_load_ps( MMCAST(A0_off + 12) );
         A1 = _mm_load_ps( MMCAST(A0_off + 72) );
         A2 = _mm_load_ps( MMCAST(A0_off + 132) );
         A3 = _mm_load_ps( MMCAST(A0_off + 192) );
         A4 = _mm_load_ps( MMCAST(A0_off + 252) );
         A5 = _mm_load_ps( MMCAST(A0_off + 312) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 12) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 16 */
         A0 = _mm_load_ps( MMCAST(A0_off + 16) );
         A1 = _mm_load_ps( MMCAST(A0_off + 76) );
         A2 = _mm_load_ps( MMCAST(A0_off + 136) );
         A3 = _mm_load_ps( MMCAST(A0_off + 196) );
         A4 = _mm_load_ps( MMCAST(A0_off + 256) );
         A5 = _mm_load_ps( MMCAST(A0_off + 316) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 16) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 20 */
         A0 = _mm_load_ps( MMCAST(A0_off + 20) );
         A1 = _mm_load_ps( MMCAST(A0_off + 80) );
         A2 = _mm_load_ps( MMCAST(A0_off + 140) );
         A3 = _mm_load_ps( MMCAST(A0_off + 200) );
         A4 = _mm_load_ps( MMCAST(A0_off + 260) );
         A5 = _mm_load_ps( MMCAST(A0_off + 320) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 20) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 24 */
         A0 = _mm_load_ps( MMCAST(A0_off + 24) );
         A1 = _mm_load_ps( MMCAST(A0_off + 84) );
         A2 = _mm_load_ps( MMCAST(A0_off + 144) );
         A3 = _mm_load_ps( MMCAST(A0_off + 204) );
         A4 = _mm_load_ps( MMCAST(A0_off + 264) );
         A5 = _mm_load_ps( MMCAST(A0_off + 324) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 24) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 28 */
         A0 = _mm_load_ps( MMCAST(A0_off + 28) );
         A1 = _mm_load_ps( MMCAST(A0_off + 88) );
         A2 = _mm_load_ps( MMCAST(A0_off + 148) );
         A3 = _mm_load_ps( MMCAST(A0_off + 208) );
         A4 = _mm_load_ps( MMCAST(A0_off + 268) );
         A5 = _mm_load_ps( MMCAST(A0_off + 328) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 28) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 32 */
         A0 = _mm_load_ps( MMCAST(A0_off + 32) );
         A1 = _mm_load_ps( MMCAST(A0_off + 92) );
         A2 = _mm_load_ps( MMCAST(A0_off + 152) );
         A3 = _mm_load_ps( MMCAST(A0_off + 212) );
         A4 = _mm_load_ps( MMCAST(A0_off + 272) );
         A5 = _mm_load_ps( MMCAST(A0_off + 332) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 32) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 36 */
         A0 = _mm_load_ps( MMCAST(A0_off + 36) );
         A1 = _mm_load_ps( MMCAST(A0_off + 96) );
         A2 = _mm_load_ps( MMCAST(A0_off + 156) );
         A3 = _mm_load_ps( MMCAST(A0_off + 216) );
         A4 = _mm_load_ps( MMCAST(A0_off + 276) );
         A5 = _mm_load_ps( MMCAST(A0_off + 336) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 36) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 40 */
         A0 = _mm_load_ps( MMCAST(A0_off + 40) );
         A1 = _mm_load_ps( MMCAST(A0_off + 100) );
         A2 = _mm_load_ps( MMCAST(A0_off + 160) );
         A3 = _mm_load_ps( MMCAST(A0_off + 220) );
         A4 = _mm_load_ps( MMCAST(A0_off + 280) );
         A5 = _mm_load_ps( MMCAST(A0_off + 340) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 40) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 44 */
         A0 = _mm_load_ps( MMCAST(A0_off + 44) );
         A1 = _mm_load_ps( MMCAST(A0_off + 104) );
         A2 = _mm_load_ps( MMCAST(A0_off + 164) );
         A3 = _mm_load_ps( MMCAST(A0_off + 224) );
         A4 = _mm_load_ps( MMCAST(A0_off + 284) );
         A5 = _mm_load_ps( MMCAST(A0_off + 344) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 44) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 48 */
         A0 = _mm_load_ps( MMCAST(A0_off + 48) );
         A1 = _mm_load_ps( MMCAST(A0_off + 108) );
         A2 = _mm_load_ps( MMCAST(A0_off + 168) );
         A3 = _mm_load_ps( MMCAST(A0_off + 228) );
         A4 = _mm_load_ps( MMCAST(A0_off + 288) );
         A5 = _mm_load_ps( MMCAST(A0_off + 348) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 48) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 52 */
         A0 = _mm_load_ps( MMCAST(A0_off + 52) );
         A1 = _mm_load_ps( MMCAST(A0_off + 112) );
         A2 = _mm_load_ps( MMCAST(A0_off + 172) );
         A3 = _mm_load_ps( MMCAST(A0_off + 232) );
         A4 = _mm_load_ps( MMCAST(A0_off + 292) );
         A5 = _mm_load_ps( MMCAST(A0_off + 352) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 52) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 56 */
         A0 = _mm_load_ps( MMCAST(A0_off + 56) );
         A1 = _mm_load_ps( MMCAST(A0_off + 116) );
         A2 = _mm_load_ps( MMCAST(A0_off + 176) );
         A3 = _mm_load_ps( MMCAST(A0_off + 236) );
         A4 = _mm_load_ps( MMCAST(A0_off + 296) );
         A5 = _mm_load_ps( MMCAST(A0_off + 356) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 56) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         prefetchABlock += 1*pfBlockDistance;
         /* Single Scalar Compression */
         c0_0 = _mm_hadd_ps( c0_0, c0_1 );
         c0_2 = _mm_hadd_ps( c0_2, c0_3 );
         c0_0 = _mm_hadd_ps( c0_0, c0_2 );
         
         /* additional remaining step */
         c0_4 = _mm_hadd_ps( c0_4, c0_4 );
         c0_4 = _mm_hadd_ps( c0_4, c0_4 );
         /* additional remaining step */
         c0_5 = _mm_hadd_ps( c0_5, c0_5 );
         c0_5 = _mm_hadd_ps( c0_5, c0_5 );
         /* Applying Beta */
         /* No beta will be appied */
         /* Move pointers to next iteration */  
         A0_off += unroll_a;
         
         /* Store results back to memory  */
         temp = c0_0;
         _mm_store_ss( cPtrI0+0, temp );
         temp = _mm_shuffle_ps( c0_0, c0_0,_MM_SHUFFLE(1,1,1,1));
         _mm_store_ss( cPtrI0+2, temp );
         temp = _mm_shuffle_ps( c0_0, c0_0,_MM_SHUFFLE(2,2,2,2));
         _mm_store_ss( cPtrI0+4, temp );
         temp = _mm_shuffle_ps( c0_0, c0_0,_MM_SHUFFLE(3,3,3,3));
         _mm_store_ss( cPtrI0+6, temp );
          _mm_store_ss( cPtrI0+8, c0_4 );
          _mm_store_ss( cPtrI0+10, c0_5 );
         cPtrI0 += 2*I_UNROLL;
         

      } /* End i/MB loop */

      B0_off += J_UNROLL*KB;
      cPtr += J_UNROLL*ldc_bytes;
   } /* End j/NB loop */
   /* End of generated inner loops */
}
#elif defined(BETAX)
#define ATL_INT int
#include <stdio.h>
#include <stdint.h>
#include <pmmintrin.h>

#define I_UNROLL 6
#define J_UNROLL 1
/* Is prefetched data written or just read? */
#define PF_READONLY 0
#define PF_READWRITE 1
#define PF_NO_REUSE 0

/* Default temporality of cache prefetch (1-3) */
#define PF_DEF 1
#define CACHE_LINE_SIZE 64
#define MMCAST( a ) (a)
#define MMCASTStore( a ) (a)
#define MMCASTStoreintrin( a ) (a)
#define TYPE float
void ATL_USERMM( const ATL_INT M, const ATL_INT N, const ATL_INT K,
                 const TYPE alpha, const TYPE *A, const ATL_INT lda,
                 const TYPE *B, const ATL_INT ldb,
                 const TYPE beta, TYPE *C, const ATL_INT ldc )
{
   register ATL_INT i, j, k;
   
   /* Vector registers to hold the elements of C */
   __m128 c0_0, c0_1, c0_2, c0_3, c0_4, c0_5;
   /* Vector register to hold C*beta */
   __m128 bc0_0, bc0_4, bc0_5;
   /* Temporary vector registers for use in inner loop */
   __m128 temp; 
   __m128 temp0;  
   __m128 temp1;  
   __m128 temp2;  
   __m128 temp3;  
   const __m128 betaV = _mm_set1_ps( beta ); 
   /* Pointer adjustments */  
   register const ATL_INT ldc_bytes = 2*ldc;
   
   register TYPE const *B0_off = B;
      
   register void const * prefetchABlock =  (void*)(A + 60*KB); 
   
   /* Unroll A */
   __m128 A0, a0, A1, a1, A2, a2, A3, a3, A4, a4, A5, a5;
   /* Unroll B */
   __m128 B0, B1;
   

   register const ATL_INT unroll_a = I_UNROLL*KB;
   register TYPE* cPtr = C;
   

   const ATL_INT pfBlockDistance = (6 * 1 * KB * 4) / 60;
   /* =======================================
    * Begin generated inner loops for case Non aligned
    * ======================================= */
   for( j=-60; j!=0; j+=J_UNROLL) 
   {
      register TYPE const *A0_off = A; 
      
      register TYPE *cPtrI0 = cPtr;
      

      for( i=-60; i != 0; i+= I_UNROLL )
      {
         /* K_Unrolling0 */
         A0 = _mm_load_ps( MMCAST(A0_off) );
         A1 = _mm_load_ps( MMCAST(A0_off + 60) );
         A2 = _mm_load_ps( MMCAST(A0_off + 120) );
         A3 = _mm_load_ps( MMCAST(A0_off + 180) );
         A4 = _mm_load_ps( MMCAST(A0_off + 240) );
         A5 = _mm_load_ps( MMCAST(A0_off + 300) );
         B0 = _mm_load_ps( MMCAST(B0_off) );
         c0_0 = B0;
         c0_0 = _mm_mul_ps( A0, c0_0 );
         c0_1 = B0;
         c0_1 = _mm_mul_ps( A1, c0_1 );
         c0_2 = B0;
         c0_2 = _mm_mul_ps( A2, c0_2 );
         c0_3 = B0;
         c0_3 = _mm_mul_ps( A3, c0_3 );
         c0_4 = B0;
         c0_4 = _mm_mul_ps( A4, c0_4 );
         c0_5 = B0;
         c0_5 = _mm_mul_ps( A5, c0_5 );
         
         /* Prefetch one element from the next block of A */
         __builtin_prefetch( prefetchABlock + 0*pfBlockDistance,PF_READONLY, PF_DEF );
         /* K_Unrolling: 4 */
         A0 = _mm_load_ps( MMCAST(A0_off + 4) );
         A1 = _mm_load_ps( MMCAST(A0_off + 64) );
         A2 = _mm_load_ps( MMCAST(A0_off + 124) );
         A3 = _mm_load_ps( MMCAST(A0_off + 184) );
         A4 = _mm_load_ps( MMCAST(A0_off + 244) );
         A5 = _mm_load_ps( MMCAST(A0_off + 304) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 4) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 8 */
         A0 = _mm_load_ps( MMCAST(A0_off + 8) );
         A1 = _mm_load_ps( MMCAST(A0_off + 68) );
         A2 = _mm_load_ps( MMCAST(A0_off + 128) );
         A3 = _mm_load_ps( MMCAST(A0_off + 188) );
         A4 = _mm_load_ps( MMCAST(A0_off + 248) );
         A5 = _mm_load_ps( MMCAST(A0_off + 308) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 8) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 12 */
         A0 = _mm_load_ps( MMCAST(A0_off + 12) );
         A1 = _mm_load_ps( MMCAST(A0_off + 72) );
         A2 = _mm_load_ps( MMCAST(A0_off + 132) );
         A3 = _mm_load_ps( MMCAST(A0_off + 192) );
         A4 = _mm_load_ps( MMCAST(A0_off + 252) );
         A5 = _mm_load_ps( MMCAST(A0_off + 312) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 12) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 16 */
         A0 = _mm_load_ps( MMCAST(A0_off + 16) );
         A1 = _mm_load_ps( MMCAST(A0_off + 76) );
         A2 = _mm_load_ps( MMCAST(A0_off + 136) );
         A3 = _mm_load_ps( MMCAST(A0_off + 196) );
         A4 = _mm_load_ps( MMCAST(A0_off + 256) );
         A5 = _mm_load_ps( MMCAST(A0_off + 316) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 16) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 20 */
         A0 = _mm_load_ps( MMCAST(A0_off + 20) );
         A1 = _mm_load_ps( MMCAST(A0_off + 80) );
         A2 = _mm_load_ps( MMCAST(A0_off + 140) );
         A3 = _mm_load_ps( MMCAST(A0_off + 200) );
         A4 = _mm_load_ps( MMCAST(A0_off + 260) );
         A5 = _mm_load_ps( MMCAST(A0_off + 320) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 20) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 24 */
         A0 = _mm_load_ps( MMCAST(A0_off + 24) );
         A1 = _mm_load_ps( MMCAST(A0_off + 84) );
         A2 = _mm_load_ps( MMCAST(A0_off + 144) );
         A3 = _mm_load_ps( MMCAST(A0_off + 204) );
         A4 = _mm_load_ps( MMCAST(A0_off + 264) );
         A5 = _mm_load_ps( MMCAST(A0_off + 324) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 24) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 28 */
         A0 = _mm_load_ps( MMCAST(A0_off + 28) );
         A1 = _mm_load_ps( MMCAST(A0_off + 88) );
         A2 = _mm_load_ps( MMCAST(A0_off + 148) );
         A3 = _mm_load_ps( MMCAST(A0_off + 208) );
         A4 = _mm_load_ps( MMCAST(A0_off + 268) );
         A5 = _mm_load_ps( MMCAST(A0_off + 328) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 28) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 32 */
         A0 = _mm_load_ps( MMCAST(A0_off + 32) );
         A1 = _mm_load_ps( MMCAST(A0_off + 92) );
         A2 = _mm_load_ps( MMCAST(A0_off + 152) );
         A3 = _mm_load_ps( MMCAST(A0_off + 212) );
         A4 = _mm_load_ps( MMCAST(A0_off + 272) );
         A5 = _mm_load_ps( MMCAST(A0_off + 332) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 32) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 36 */
         A0 = _mm_load_ps( MMCAST(A0_off + 36) );
         A1 = _mm_load_ps( MMCAST(A0_off + 96) );
         A2 = _mm_load_ps( MMCAST(A0_off + 156) );
         A3 = _mm_load_ps( MMCAST(A0_off + 216) );
         A4 = _mm_load_ps( MMCAST(A0_off + 276) );
         A5 = _mm_load_ps( MMCAST(A0_off + 336) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 36) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 40 */
         A0 = _mm_load_ps( MMCAST(A0_off + 40) );
         A1 = _mm_load_ps( MMCAST(A0_off + 100) );
         A2 = _mm_load_ps( MMCAST(A0_off + 160) );
         A3 = _mm_load_ps( MMCAST(A0_off + 220) );
         A4 = _mm_load_ps( MMCAST(A0_off + 280) );
         A5 = _mm_load_ps( MMCAST(A0_off + 340) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 40) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 44 */
         A0 = _mm_load_ps( MMCAST(A0_off + 44) );
         A1 = _mm_load_ps( MMCAST(A0_off + 104) );
         A2 = _mm_load_ps( MMCAST(A0_off + 164) );
         A3 = _mm_load_ps( MMCAST(A0_off + 224) );
         A4 = _mm_load_ps( MMCAST(A0_off + 284) );
         A5 = _mm_load_ps( MMCAST(A0_off + 344) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 44) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 48 */
         A0 = _mm_load_ps( MMCAST(A0_off + 48) );
         A1 = _mm_load_ps( MMCAST(A0_off + 108) );
         A2 = _mm_load_ps( MMCAST(A0_off + 168) );
         A3 = _mm_load_ps( MMCAST(A0_off + 228) );
         A4 = _mm_load_ps( MMCAST(A0_off + 288) );
         A5 = _mm_load_ps( MMCAST(A0_off + 348) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 48) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 52 */
         A0 = _mm_load_ps( MMCAST(A0_off + 52) );
         A1 = _mm_load_ps( MMCAST(A0_off + 112) );
         A2 = _mm_load_ps( MMCAST(A0_off + 172) );
         A3 = _mm_load_ps( MMCAST(A0_off + 232) );
         A4 = _mm_load_ps( MMCAST(A0_off + 292) );
         A5 = _mm_load_ps( MMCAST(A0_off + 352) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 52) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 56 */
         A0 = _mm_load_ps( MMCAST(A0_off + 56) );
         A1 = _mm_load_ps( MMCAST(A0_off + 116) );
         A2 = _mm_load_ps( MMCAST(A0_off + 176) );
         A3 = _mm_load_ps( MMCAST(A0_off + 236) );
         A4 = _mm_load_ps( MMCAST(A0_off + 296) );
         A5 = _mm_load_ps( MMCAST(A0_off + 356) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 56) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         prefetchABlock += 1*pfBlockDistance;
         /* Single Scalar Compression */
         c0_0 = _mm_hadd_ps( c0_0, c0_1 );
         c0_2 = _mm_hadd_ps( c0_2, c0_3 );
         c0_0 = _mm_hadd_ps( c0_0, c0_2 );
         
         /* additional remaining step */
         c0_4 = _mm_hadd_ps( c0_4, c0_4 );
         c0_4 = _mm_hadd_ps( c0_4, c0_4 );
         /* additional remaining step */
         c0_5 = _mm_hadd_ps( c0_5, c0_5 );
         c0_5 = _mm_hadd_ps( c0_5, c0_5 );
         /* Applying Beta */
            /* Apply Beta Factor */
            /* Load C from memory */
            temp0 = _mm_load_ss( cPtrI0 + 0 );
            temp1 = _mm_load_ss( cPtrI0 + 2 );
            temp2 = _mm_load_ss( cPtrI0 + 4 );
            temp3 = _mm_load_ss( cPtrI0 + 6 );
            temp0 = _mm_unpacklo_ps( temp0, temp1 );
            temp2 = _mm_unpacklo_ps( temp2, temp3 );
            bc0_0 = _mm_movelh_ps( temp0, temp2 );
            bc0_0 = _mm_mul_ps( betaV, bc0_0 );
            /* 2 remaining */
            bc0_4 = _mm_load_ss( cPtrI0+8 );
            bc0_4 = _mm_mul_ss( betaV, bc0_4 );
            /* 1 remaining */
            bc0_5 = _mm_load_ss( cPtrI0+10 );
            bc0_5 = _mm_mul_ss( betaV, bc0_5 );
            /* C = (beta*C) + (matrix multiply) */
            c0_0 = _mm_add_ps( bc0_0, c0_0 );
            c0_4 = _mm_add_ss( bc0_4, c0_4 );
            c0_5 = _mm_add_ss( bc0_5, c0_5 );
         /* Move pointers to next iteration */  
         A0_off += unroll_a;
         
         /* Store results back to memory  */
         temp = c0_0;
         _mm_store_ss( cPtrI0+0, temp );
         temp = _mm_shuffle_ps( c0_0, c0_0,_MM_SHUFFLE(1,1,1,1));
         _mm_store_ss( cPtrI0+2, temp );
         temp = _mm_shuffle_ps( c0_0, c0_0,_MM_SHUFFLE(2,2,2,2));
         _mm_store_ss( cPtrI0+4, temp );
         temp = _mm_shuffle_ps( c0_0, c0_0,_MM_SHUFFLE(3,3,3,3));
         _mm_store_ss( cPtrI0+6, temp );
          _mm_store_ss( cPtrI0+8, c0_4 );
          _mm_store_ss( cPtrI0+10, c0_5 );
         cPtrI0 += 2*I_UNROLL;
         

      } /* End i/MB loop */

      B0_off += J_UNROLL*KB;
      cPtr += J_UNROLL*ldc_bytes;
   } /* End j/NB loop */
   /* End of generated inner loops */
}
#else
#define ATL_INT int
#include <stdio.h>
#include <stdint.h>
#include <pmmintrin.h>

#define I_UNROLL 6
#define J_UNROLL 1
/* Is prefetched data written or just read? */
#define PF_READONLY 0
#define PF_READWRITE 1
#define PF_NO_REUSE 0

/* Default temporality of cache prefetch (1-3) */
#define PF_DEF 1
#define CACHE_LINE_SIZE 64
#define MMCAST( a ) (a)
#define MMCASTStore( a ) (a)
#define MMCASTStoreintrin( a ) (a)
#define TYPE float
void ATL_USERMM( const ATL_INT M, const ATL_INT N, const ATL_INT K,
                 const TYPE alpha, const TYPE *A, const ATL_INT lda,
                 const TYPE *B, const ATL_INT ldb,
                 const TYPE beta, TYPE *C, const ATL_INT ldc )
{
   register ATL_INT i, j, k;
   
   /* Vector registers to hold the elements of C */
   __m128 c0_0, c0_1, c0_2, c0_3, c0_4, c0_5;
   /* Vector register to hold C*beta */
   __m128 bc0_0, bc0_4, bc0_5;
   /* Temporary vector registers for use in inner loop */
   __m128 temp; 
   __m128 temp0;  
   __m128 temp1;  
   __m128 temp2;  
   __m128 temp3;  
   /* Pointer adjustments */  
   register const ATL_INT ldc_bytes = 2*ldc;
   
   register TYPE const *B0_off = B;
      
   register void const * prefetchABlock =  (void*)(A + 60*KB); 
   
   /* Unroll A */
   __m128 A0, a0, A1, a1, A2, a2, A3, a3, A4, a4, A5, a5;
   /* Unroll B */
   __m128 B0, B1;
   

   register const ATL_INT unroll_a = I_UNROLL*KB;
   register TYPE* cPtr = C;
   

   const ATL_INT pfBlockDistance = (6 * 1 * KB * 4) / 60;
   /* =======================================
    * Begin generated inner loops for case Non aligned
    * ======================================= */
   for( j=-60; j!=0; j+=J_UNROLL) 
   {
      register TYPE const *A0_off = A; 
      
      register TYPE *cPtrI0 = cPtr;
      

      for( i=-60; i != 0; i+= I_UNROLL )
      {
         /* K_Unrolling0 */
         A0 = _mm_load_ps( MMCAST(A0_off) );
         A1 = _mm_load_ps( MMCAST(A0_off + 60) );
         A2 = _mm_load_ps( MMCAST(A0_off + 120) );
         A3 = _mm_load_ps( MMCAST(A0_off + 180) );
         A4 = _mm_load_ps( MMCAST(A0_off + 240) );
         A5 = _mm_load_ps( MMCAST(A0_off + 300) );
         B0 = _mm_load_ps( MMCAST(B0_off) );
         c0_0 = B0;
         c0_0 = _mm_mul_ps( A0, c0_0 );
         c0_1 = B0;
         c0_1 = _mm_mul_ps( A1, c0_1 );
         c0_2 = B0;
         c0_2 = _mm_mul_ps( A2, c0_2 );
         c0_3 = B0;
         c0_3 = _mm_mul_ps( A3, c0_3 );
         c0_4 = B0;
         c0_4 = _mm_mul_ps( A4, c0_4 );
         c0_5 = B0;
         c0_5 = _mm_mul_ps( A5, c0_5 );
         
         /* Prefetch one element from the next block of A */
         __builtin_prefetch( prefetchABlock + 0*pfBlockDistance,PF_READONLY, PF_DEF );
         /* K_Unrolling: 4 */
         A0 = _mm_load_ps( MMCAST(A0_off + 4) );
         A1 = _mm_load_ps( MMCAST(A0_off + 64) );
         A2 = _mm_load_ps( MMCAST(A0_off + 124) );
         A3 = _mm_load_ps( MMCAST(A0_off + 184) );
         A4 = _mm_load_ps( MMCAST(A0_off + 244) );
         A5 = _mm_load_ps( MMCAST(A0_off + 304) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 4) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 8 */
         A0 = _mm_load_ps( MMCAST(A0_off + 8) );
         A1 = _mm_load_ps( MMCAST(A0_off + 68) );
         A2 = _mm_load_ps( MMCAST(A0_off + 128) );
         A3 = _mm_load_ps( MMCAST(A0_off + 188) );
         A4 = _mm_load_ps( MMCAST(A0_off + 248) );
         A5 = _mm_load_ps( MMCAST(A0_off + 308) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 8) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 12 */
         A0 = _mm_load_ps( MMCAST(A0_off + 12) );
         A1 = _mm_load_ps( MMCAST(A0_off + 72) );
         A2 = _mm_load_ps( MMCAST(A0_off + 132) );
         A3 = _mm_load_ps( MMCAST(A0_off + 192) );
         A4 = _mm_load_ps( MMCAST(A0_off + 252) );
         A5 = _mm_load_ps( MMCAST(A0_off + 312) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 12) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 16 */
         A0 = _mm_load_ps( MMCAST(A0_off + 16) );
         A1 = _mm_load_ps( MMCAST(A0_off + 76) );
         A2 = _mm_load_ps( MMCAST(A0_off + 136) );
         A3 = _mm_load_ps( MMCAST(A0_off + 196) );
         A4 = _mm_load_ps( MMCAST(A0_off + 256) );
         A5 = _mm_load_ps( MMCAST(A0_off + 316) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 16) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 20 */
         A0 = _mm_load_ps( MMCAST(A0_off + 20) );
         A1 = _mm_load_ps( MMCAST(A0_off + 80) );
         A2 = _mm_load_ps( MMCAST(A0_off + 140) );
         A3 = _mm_load_ps( MMCAST(A0_off + 200) );
         A4 = _mm_load_ps( MMCAST(A0_off + 260) );
         A5 = _mm_load_ps( MMCAST(A0_off + 320) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 20) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 24 */
         A0 = _mm_load_ps( MMCAST(A0_off + 24) );
         A1 = _mm_load_ps( MMCAST(A0_off + 84) );
         A2 = _mm_load_ps( MMCAST(A0_off + 144) );
         A3 = _mm_load_ps( MMCAST(A0_off + 204) );
         A4 = _mm_load_ps( MMCAST(A0_off + 264) );
         A5 = _mm_load_ps( MMCAST(A0_off + 324) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 24) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 28 */
         A0 = _mm_load_ps( MMCAST(A0_off + 28) );
         A1 = _mm_load_ps( MMCAST(A0_off + 88) );
         A2 = _mm_load_ps( MMCAST(A0_off + 148) );
         A3 = _mm_load_ps( MMCAST(A0_off + 208) );
         A4 = _mm_load_ps( MMCAST(A0_off + 268) );
         A5 = _mm_load_ps( MMCAST(A0_off + 328) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 28) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 32 */
         A0 = _mm_load_ps( MMCAST(A0_off + 32) );
         A1 = _mm_load_ps( MMCAST(A0_off + 92) );
         A2 = _mm_load_ps( MMCAST(A0_off + 152) );
         A3 = _mm_load_ps( MMCAST(A0_off + 212) );
         A4 = _mm_load_ps( MMCAST(A0_off + 272) );
         A5 = _mm_load_ps( MMCAST(A0_off + 332) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 32) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 36 */
         A0 = _mm_load_ps( MMCAST(A0_off + 36) );
         A1 = _mm_load_ps( MMCAST(A0_off + 96) );
         A2 = _mm_load_ps( MMCAST(A0_off + 156) );
         A3 = _mm_load_ps( MMCAST(A0_off + 216) );
         A4 = _mm_load_ps( MMCAST(A0_off + 276) );
         A5 = _mm_load_ps( MMCAST(A0_off + 336) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 36) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 40 */
         A0 = _mm_load_ps( MMCAST(A0_off + 40) );
         A1 = _mm_load_ps( MMCAST(A0_off + 100) );
         A2 = _mm_load_ps( MMCAST(A0_off + 160) );
         A3 = _mm_load_ps( MMCAST(A0_off + 220) );
         A4 = _mm_load_ps( MMCAST(A0_off + 280) );
         A5 = _mm_load_ps( MMCAST(A0_off + 340) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 40) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 44 */
         A0 = _mm_load_ps( MMCAST(A0_off + 44) );
         A1 = _mm_load_ps( MMCAST(A0_off + 104) );
         A2 = _mm_load_ps( MMCAST(A0_off + 164) );
         A3 = _mm_load_ps( MMCAST(A0_off + 224) );
         A4 = _mm_load_ps( MMCAST(A0_off + 284) );
         A5 = _mm_load_ps( MMCAST(A0_off + 344) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 44) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 48 */
         A0 = _mm_load_ps( MMCAST(A0_off + 48) );
         A1 = _mm_load_ps( MMCAST(A0_off + 108) );
         A2 = _mm_load_ps( MMCAST(A0_off + 168) );
         A3 = _mm_load_ps( MMCAST(A0_off + 228) );
         A4 = _mm_load_ps( MMCAST(A0_off + 288) );
         A5 = _mm_load_ps( MMCAST(A0_off + 348) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 48) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 52 */
         A0 = _mm_load_ps( MMCAST(A0_off + 52) );
         A1 = _mm_load_ps( MMCAST(A0_off + 112) );
         A2 = _mm_load_ps( MMCAST(A0_off + 172) );
         A3 = _mm_load_ps( MMCAST(A0_off + 232) );
         A4 = _mm_load_ps( MMCAST(A0_off + 292) );
         A5 = _mm_load_ps( MMCAST(A0_off + 352) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 52) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         /* K_Unrolling: 56 */
         A0 = _mm_load_ps( MMCAST(A0_off + 56) );
         A1 = _mm_load_ps( MMCAST(A0_off + 116) );
         A2 = _mm_load_ps( MMCAST(A0_off + 176) );
         A3 = _mm_load_ps( MMCAST(A0_off + 236) );
         A4 = _mm_load_ps( MMCAST(A0_off + 296) );
         A5 = _mm_load_ps( MMCAST(A0_off + 356) );
         
         B0 = _mm_load_ps( MMCAST(B0_off + 56) );
         A0 = _mm_mul_ps( B0, A0 );
         c0_0 = _mm_add_ps( A0, c0_0 );
         A1 = _mm_mul_ps( B0, A1 );
         c0_1 = _mm_add_ps( A1, c0_1 );
         A2 = _mm_mul_ps( B0, A2 );
         c0_2 = _mm_add_ps( A2, c0_2 );
         A3 = _mm_mul_ps( B0, A3 );
         c0_3 = _mm_add_ps( A3, c0_3 );
         A4 = _mm_mul_ps( B0, A4 );
         c0_4 = _mm_add_ps( A4, c0_4 );
         A5 = _mm_mul_ps( B0, A5 );
         c0_5 = _mm_add_ps( A5, c0_5 );
         prefetchABlock += 1*pfBlockDistance;
         /* Single Scalar Compression */
         c0_0 = _mm_hadd_ps( c0_0, c0_1 );
         c0_2 = _mm_hadd_ps( c0_2, c0_3 );
         c0_0 = _mm_hadd_ps( c0_0, c0_2 );
         
         /* additional remaining step */
         c0_4 = _mm_hadd_ps( c0_4, c0_4 );
         c0_4 = _mm_hadd_ps( c0_4, c0_4 );
         /* additional remaining step */
         c0_5 = _mm_hadd_ps( c0_5, c0_5 );
         c0_5 = _mm_hadd_ps( c0_5, c0_5 );
         /* Applying Beta */
            /* Apply Beta Factor */
            /* Load C from memory */
            temp0 = _mm_load_ss( cPtrI0 + 0 );
            temp1 = _mm_load_ss( cPtrI0 + 2 );
            temp2 = _mm_load_ss( cPtrI0 + 4 );
            temp3 = _mm_load_ss( cPtrI0 + 6 );
            temp0 = _mm_unpacklo_ps( temp0, temp1 );
            temp2 = _mm_unpacklo_ps( temp2, temp3 );
            bc0_0 = _mm_movelh_ps( temp0, temp2 );
            /* 2 remaining */
            bc0_4 = _mm_load_ss( cPtrI0+8 );
            /* 1 remaining */
            bc0_5 = _mm_load_ss( cPtrI0+10 );
            /* C = (beta*C) + (matrix multiply) */
            c0_0 = _mm_add_ps( bc0_0, c0_0 );
            c0_4 = _mm_add_ss( bc0_4, c0_4 );
            c0_5 = _mm_add_ss( bc0_5, c0_5 );
         /* Move pointers to next iteration */  
         A0_off += unroll_a;
         
         /* Store results back to memory  */
         temp = c0_0;
         _mm_store_ss( cPtrI0+0, temp );
         temp = _mm_shuffle_ps( c0_0, c0_0,_MM_SHUFFLE(1,1,1,1));
         _mm_store_ss( cPtrI0+2, temp );
         temp = _mm_shuffle_ps( c0_0, c0_0,_MM_SHUFFLE(2,2,2,2));
         _mm_store_ss( cPtrI0+4, temp );
         temp = _mm_shuffle_ps( c0_0, c0_0,_MM_SHUFFLE(3,3,3,3));
         _mm_store_ss( cPtrI0+6, temp );
          _mm_store_ss( cPtrI0+8, c0_4 );
          _mm_store_ss( cPtrI0+10, c0_5 );
         cPtrI0 += 2*I_UNROLL;
         

      } /* End i/MB loop */

      B0_off += J_UNROLL*KB;
      cPtr += J_UNROLL*ldc_bytes;
   } /* End j/NB loop */
   /* End of generated inner loops */
}
#endif
